#pragma once

#include "ehs/Str.h"

namespace ehs
{
    class HeaderVar
    {
    private:
        UInt_64 id;
        Str_8 name;
        Str_8 value;

    public:
        HeaderVar();

        HeaderVar(Str_8 name, Str_8 value);

        HeaderVar(HeaderVar &&other) noexcept;

        HeaderVar(const HeaderVar &other);

        HeaderVar &operator=(HeaderVar &&other) noexcept;

        HeaderVar &operator=(const HeaderVar &other);

        bool operator==(const HeaderVar &other) const;

        bool operator!=(const HeaderVar &other) const;

        bool operator==(const UInt_64 &otherId) const;

        bool operator!=(const UInt_64 &otherId) const;

        UInt_64 GetId() const;

        Str_8 GetName() const;

        Str_8 GetValue() const;

        void SetValue(Str_8 value);

        Str_8 ToStr() const;
    };
}
