#pragma once

#include "ehs/Str.h"

namespace ehs
{
    class QueryVar
    {
    private:
        UInt_64 id;
        Str_8 name;
        Str_8 value;

    public:
        QueryVar();

        QueryVar(Str_8 name, Str_8 value);

        QueryVar(QueryVar &&other) noexcept;

        QueryVar(const QueryVar &other);

        QueryVar &operator=(QueryVar &&other) noexcept;

        QueryVar &operator=(const QueryVar &other);

        bool operator==(const QueryVar &other) const;

        bool operator!=(const QueryVar &other) const;

        bool operator==(const UInt_64 &otherId) const;

        bool operator!=(const UInt_64 &otherId) const;

        UInt_64 GetId() const;

        Str_8 GetName() const;

        Str_8 GetValue() const;

        void SetValue(Str_8 value);

        Str_8 ToStr() const;
    };
}