#include "ehs/io/socket/QueryVar.h"

namespace ehs
{
    QueryVar::QueryVar()
        : id(0)
    {
    }

    QueryVar::QueryVar(Str_8 name, Str_8 value)
        : id(name.Hash_64()), name((Str_8 &&)name), value((Str_8 &&)value)
    {
    }

    QueryVar::QueryVar(QueryVar&& other) noexcept
        : id(other.id), name((Str_8 &&)other.name), value((Str_8 &&)other.value)
    {
        other.id = 0;
    }

    QueryVar::QueryVar(const QueryVar& other)
        : id(other.id), name(other.name), value(other.value)
    {
    }

    QueryVar& QueryVar::operator=(QueryVar&& other) noexcept
    {
        if (this == &other)
            return *this;

        id = other.id;
        name = (Str_8 &&)other.name;
        value = (Str_8 &&)other.value;

        other.id = 0;

        return *this;
    }

    QueryVar& QueryVar::operator=(const QueryVar& other)
    {
        if (this == &other)
            return *this;

        id = other.id;
        name = other.name;
        value = other.value;

        return *this;
    }

    bool QueryVar::operator==(const QueryVar& other) const
    {
        return id == other.id;
    }

    bool QueryVar::operator!=(const QueryVar& other) const
    {
        return id != other.id;
    }

    bool QueryVar::operator==(const UInt_64& otherId) const
    {
        return id == otherId;
    }

    bool QueryVar::operator!=(const UInt_64& otherId) const
    {
        return id != otherId;
    }

    UInt_64 QueryVar::GetId() const
    {
        return id;
    }

    Str_8 QueryVar::GetName() const
    {
        return name;
    }

    Str_8 QueryVar::GetValue() const
    {
        return value;
    }

    void QueryVar::SetValue(Str_8 value)
    {
        this->value = (Str_8 &&)value;
    }

    Str_8 QueryVar::ToStr() const
    {
        return name + "=" + value;
    }
}
